
var lmdb = require('..');
var env = new lmdb.Env();
env.open({
    // Path to the environment
    path: "./testdata",
    // Maximum number of databases
    maxDbs: 10
});

// Ensure that the database is empty
var dbi = env.openDbi({
   name: "mydb4",
   create: true
});
dbi.drop();
dbi = env.openDbi({
   name: "mydb4",
   create: true
});

// Write test values

var txn0 = env.beginTxn();
txn0.putString(dbi, "a", "Helló1");
txn0.putString(dbi, "b", "Hello2");
txn0.putString(dbi, "c", "cccc");
/* key 'd' is omitted intentionally */
txn0.putString(dbi, "e", "eeeee");
txn0.putString(dbi, "f", "ffff");
txn0.putString(dbi, "g", "Hello6");
/* key 'h' is omitted intentionally */
txn0.putString(dbi, "i", "iiii");
txn0.putString(dbi, "j", "jjjj");
txn0.commit();
console.log("wrote initial values");

var printFunc = function(key, data) {
    console.log("----->  key:", key);
    console.log("-----> data:", data);
}

// Begin transaction
var txn = env.beginTxn({ readOnly: true });
// Create cursor
var cursor = new lmdb.Cursor(txn, dbi);

cursor.goToNearest = function(searchKey) {
    var key = cursor.goToRange(searchKey);
    if (searchKey !== key) {
        key = cursor.goToPrev();
    }
    return key;
};

var k;
k = cursor.goToNearest('d');
printFunc(k, cursor.getCurrentString());
k = cursor.goToNearest('k');
printFunc(k, cursor.getCurrentString());

// Close cursor
cursor.close();
// Abort transaction
txn.abort();

dbi.close();
env.close();

